<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.root_files &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.root_files</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.root_files</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to open the ROOT files of interest.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">Union</span><span class="p">,</span> <span class="n">Tuple</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">lib</span> <span class="kn">import</span> <span class="n">open_samples</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_sample</span> <span class="kn">import</span> <span class="n">compute_columns</span><span class="p">,</span> <span class="n">merge_columns</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_str</span> <span class="kn">import</span> <span class="n">fmt</span>

<span class="kn">from</span> <span class="nn">multiple_candidates.definition.paths</span> <span class="kn">import</span> <span class="n">TREE_NAME</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">particles</span><span class="p">,</span> <span class="n">columns</span><span class="p">,</span> <span class="n">paths</span>
<span class="p">)</span>


<div class="viewcode-block" id="open_dataframes"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.root_files.open_dataframes">[docs]</a><span class="k">def</span> <span class="nf">open_dataframes</span><span class="p">(</span>
    <span class="n">folder_path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">file_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
    <span class="n">list_years</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">list_magnets</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">list_columns</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">tree_name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">TREE_NAME</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Open ROOT files for every year and magnet polarisation, using uproot4.</span>

<span class="sd">    Args:</span>
<span class="sd">        file_path : path where the ROOT files are located.</span>
<span class="sd">        file_name : name of the ROOT files, with wildcards `{y}` for the</span>
<span class="sd">            years, and `{m}` for months.</span>
<span class="sd">        list_years: list of years (default are 2016, 2017 and 2018)</span>
<span class="sd">        list_magnets : list of magnets (default are `U` and `D`)</span>
<span class="sd">        list_columns : list of columns to load. By default, load every columns</span>
<span class="sd">        tree_name: tree name in the ROOT file</span>
<span class="sd">        verbose : whether to show the paths of the files that are loaded</span>
<span class="sd">        compl_mode : if set to `True`, `list_columns` are the columns</span>
<span class="sd">            not to load.</span>
<span class="sd">        reset_index: reset the indices of the resulting dataframe</span>

<span class="sd">    Returns:</span>
<span class="sd">        concatenated dataframe of all the dataframes.</span>
<span class="sd">        Contains 2 new columns `year` and `magnet`.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Default values of list_years nand list_magnets</span>
    <span class="k">if</span> <span class="n">list_years</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">list_years</span> <span class="o">=</span> <span class="p">[</span><span class="mi">2016</span><span class="p">,</span> <span class="mi">2017</span><span class="p">,</span> <span class="mi">2018</span><span class="p">]</span>
    <span class="k">if</span> <span class="n">list_magnets</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">list_magnets</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;D&#39;</span><span class="p">,</span> <span class="s1">&#39;U&#39;</span><span class="p">]</span>

    <span class="n">list_file_paths</span> <span class="o">=</span> <span class="p">[</span>
        <span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">folder_path</span><span class="p">,</span> <span class="n">file_name</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">y</span><span class="o">=</span><span class="n">year</span><span class="p">,</span> <span class="n">m</span><span class="o">=</span><span class="n">magnet</span><span class="p">))</span>
        <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">list_years</span>
        <span class="k">for</span> <span class="n">magnet</span> <span class="ow">in</span> <span class="n">list_magnets</span>
    <span class="p">]</span>

    <span class="n">dict_new_columns</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="n">dict_new_columns</span><span class="p">[</span><span class="s2">&quot;magnet&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">dict_new_columns</span><span class="p">[</span><span class="s2">&quot;year&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">list_years</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">magnet</span> <span class="ow">in</span> <span class="n">list_magnets</span><span class="p">:</span>
            <span class="n">dict_new_columns</span><span class="p">[</span><span class="s2">&quot;magnet&quot;</span><span class="p">]</span> <span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">magnet</span><span class="p">)</span>
            <span class="n">dict_new_columns</span><span class="p">[</span><span class="s2">&quot;year&quot;</span><span class="p">]</span> <span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">year</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">open_samples</span><span class="p">(</span>
        <span class="n">list_file_paths</span><span class="p">,</span> <span class="n">tree_name</span><span class="o">=</span><span class="n">tree_name</span><span class="p">,</span> <span class="n">list_columns</span><span class="o">=</span><span class="n">list_columns</span><span class="p">,</span>
        <span class="n">dict_new_columns</span><span class="o">=</span><span class="n">dict_new_columns</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="compute_endvertex_chi2ndof"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.root_files.compute_endvertex_chi2ndof">[docs]</a><span class="k">def</span> <span class="nf">compute_endvertex_chi2ndof</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">list_particles</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Dst&quot;</span><span class="p">]</span>
<span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Compute the variable</span>
<span class="sd">    ``ENDVERTEX_CHI2NDOF = ENDVERTEX_CHI2 / ENDVERTEX_CHI2NDOF``</span>
<span class="sd">    for a list of particles. In-place. Add the variable to the</span>
<span class="sd">    sample under the name ``{particle_alias}_{ENDVERTEX_CHI2NDOF}``.</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: sample</span>
<span class="sd">        list_particles: list of particles which the variable</span>
<span class="sd">            ``ENDVERTEX_CHI2NDOF`` is computed.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">for</span> <span class="n">particle</span> <span class="ow">in</span> <span class="n">list_particles</span><span class="p">:</span>
        <span class="n">particle_alias</span> <span class="o">=</span> <span class="n">particles</span><span class="o">.</span><span class="n">dict_particle_aliases</span><span class="p">[</span><span class="n">particle</span><span class="p">]</span>
        <span class="n">column_name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{particle_alias}</span><span class="s2">_ENDVERTEX_CHI2NDOF&quot;</span>
        <span class="n">dataframe</span><span class="o">.</span><span class="n">loc</span><span class="p">[:,</span> <span class="n">column_name</span><span class="p">]</span> <span class="o">=</span> \
            <span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{particle_alias}</span><span class="s2">_ENDVERTEX_CHI2&quot;</span><span class="p">]</span>
             <span class="o">/</span> <span class="n">dataframe</span><span class="p">[</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{particle_alias}</span><span class="s2">_ENDVERTEX_NDOF&quot;</span><span class="p">])</span></div>


<div class="viewcode-block" id="process_sample"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.root_files.process_sample">[docs]</a><span class="k">def</span> <span class="nf">process_sample</span><span class="p">(</span>
        <span class="n">sample</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
        <span class="n">list_columns_to_compute</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Process a sample. In-place.</span>

<span class="sd">    * compute columns</span>
<span class="sd">    * add the ``EVENT_COLUMN``</span>
<span class="sd">    * compute ``B_ENDVERTEX_CHI2NDOF``</span>

<span class="sd">    Args:</span>
<span class="sd">        sample: pandas DataFrame</span>
<span class="sd">        list_columns_to_compute: list of the columns to compute</span>
<span class="sd">            using :py:func:`lib.handle.handle_sample.compute_columns`.</span>
<span class="sd">            If not given, taken to be</span>
<span class="sd">            ``definition.loaded_columns.list_columns_to_compute``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">list_columns_to_compute</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">loaded_columns</span>
        <span class="n">list_columns_to_compute</span> <span class="o">=</span> <span class="n">loaded_columns</span><span class="o">.</span><span class="n">list_columns_to_compute</span>
    <span class="n">compute_endvertex_chi2ndof</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span>
    <span class="n">compute_columns</span><span class="p">(</span>
        <span class="n">sample</span><span class="p">,</span>
        <span class="n">list_columns_to_compute</span>
    <span class="p">)</span>
    <span class="n">merge_columns</span><span class="p">(</span>
        <span class="n">sample</span><span class="p">,</span>
        <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMNS</span><span class="p">,</span>
        <span class="n">merged_column</span><span class="o">=</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="load_process_all_samples"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.root_files.load_process_all_samples">[docs]</a><span class="k">def</span> <span class="nf">load_process_all_samples</span><span class="p">(</span>
    <span class="n">list_sample_types</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">flavour</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
    <span class="n">list_loaded_columns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">indir</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">paths</span><span class="o">.</span><span class="n">default_indir</span><span class="p">,</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot;Load and process samples</span>

<span class="sd">    Args:</span>
<span class="sd">        list_sample_types: list of the sample types to load</span>
<span class="sd">        flavour: flavour to load (``Electron`` or ``Mu``)</span>
<span class="sd">        indir: directory where all the ROOT files are located</span>
<span class="sd">        list_loaded_columns: list of the columns that are loaded</span>

<span class="sd">    Returns:</span>
<span class="sd">        associates a sample type with a sample that is processed</span>
<span class="sd">        and contains the necessary samples</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dict_dataframes</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">sample_type</span> <span class="ow">in</span> <span class="n">list_sample_types</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Load </span><span class="si">{sample_type}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="s2">&quot;=&quot;</span><span class="o">*</span><span class="mi">10</span><span class="p">)</span>
        <span class="n">dataframe</span> <span class="o">=</span> <span class="n">open_dataframes</span><span class="p">(</span>
            <span class="n">indir</span><span class="p">,</span>
            <span class="n">fmt</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">paths</span><span class="o">.</span><span class="n">DICT_FILE_NAMES</span><span class="p">[</span><span class="n">sample_type</span><span class="p">],</span> <span class="n">flavour</span><span class="o">=</span><span class="n">flavour</span><span class="p">),</span>
            <span class="n">list_columns</span><span class="o">=</span><span class="n">list_loaded_columns</span><span class="p">,</span>
        <span class="p">)</span>

        <span class="n">process_sample</span><span class="p">(</span><span class="n">dataframe</span><span class="p">)</span>
        <span class="n">dict_dataframes</span><span class="p">[</span><span class="n">sample_type</span><span class="p">]</span> <span class="o">=</span> <span class="n">dataframe</span>

    <span class="k">return</span> <span class="n">dict_dataframes</span></div>


<div class="viewcode-block" id="isolate_multiple_cat"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.root_files.isolate_multiple_cat">[docs]</a><span class="k">def</span> <span class="nf">isolate_multiple_cat</span><span class="p">(</span>
    <span class="n">sample</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">dict_shared_feature_flags_mults</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">],</span>
    <span class="n">get</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;cat&quot;</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Union</span><span class="p">[</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Isolate the category of multiple candidates given through</span>
<span class="sd">    the requirement ``multiple_candidates_cat.req_cat_mul_candidates``</span>

<span class="sd">    Args:</span>
<span class="sd">        sample: dataframe</span>
<span class="sd">        dict_shared_feature_flags_mults: Associates a candidate multiplicity</span>
<span class="sd">            with a dataframe whose columns are particle flags</span>
<span class="sd">            (which indicate if the particle is shared) or not</span>
<span class="sd">            between 2 combinations of candidates</span>
<span class="sd">        get: whether to get only the category (`cat`), or the candidates</span>
<span class="sd">            that don&#39;t belong to this category (`non_cat`) or both</span>
<span class="sd">            (`both`)</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * sample_cat: multiple candidates corresponding to the desired \</span>
<span class="sd">            category</span>
<span class="sd">        * sample_non_cat: other candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">multiple_candidates_cat</span>

    <span class="k">assert</span> <span class="n">get</span> <span class="ow">in</span> <span class="p">(</span><span class="s2">&quot;cat&quot;</span><span class="p">,</span> <span class="s2">&quot;non_cat&quot;</span><span class="p">,</span> <span class="s2">&quot;both&quot;</span><span class="p">)</span>

    <span class="n">list_list_cat_events</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">df_shared_features_flags</span> <span class="ow">in</span> <span class="n">dict_shared_feature_flags_mults</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
        <span class="n">list_list_cat_events</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">df_shared_features_flags</span><span class="o">.</span><span class="n">query</span><span class="p">(</span>
                <span class="n">multiple_candidates_cat</span><span class="o">.</span><span class="n">req_cat_mul_candidates</span>
            <span class="p">)</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">get_level_values</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
        <span class="p">)</span>
    <span class="n">list_cat_events</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">(</span><span class="n">list_list_cat_events</span><span class="p">))</span>

    <span class="n">to_return</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">get</span> <span class="ow">in</span> <span class="p">(</span><span class="s2">&quot;cat&quot;</span><span class="p">,</span> <span class="s2">&quot;both&quot;</span><span class="p">):</span>
        <span class="n">to_return</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">sample</span><span class="p">[</span><span class="n">sample</span><span class="p">[</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">list_cat_events</span><span class="p">)]</span>
        <span class="p">)</span>
    <span class="k">if</span> <span class="n">get</span> <span class="ow">in</span> <span class="p">(</span><span class="s2">&quot;non_cat&quot;</span><span class="p">,</span> <span class="s2">&quot;both&quot;</span><span class="p">):</span>
        <span class="n">to_return</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">sample</span><span class="p">[</span><span class="o">~</span><span class="n">sample</span><span class="p">[</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">list_cat_events</span><span class="p">)]</span>
        <span class="p">)</span>
    <span class="k">return</span> <span class="n">to_return</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">to_return</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="k">else</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">to_return</span><span class="p">)</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>